<!DOCTYPE html>
<html>

<head>
    <title>INF226 Private Messages</title>
    <link rel="stylesheet" href="highlight.css" />
	<link rel="icon" href="favicon.png" type="image/png" />

    <style>
        * {
            box-sizing: border-box;
            ;
        }

        #page {
            height: 100vh;
            display: flex;
            flex-direction: column;
            ;
            padding: .5rem;
        }

        main {
            border-top: 1px solid grey;
            border-bottom: 1px solid grey;
            /* min-height: 50%; */
            flex-grow: 1;
            flex-shrink: 1;
            overflow:auto;
        }

        body {
            margin: 0;
        }

        label {
            justify-self: end;
            ;
        }

        #controls {
            /* min-height: 20%; */
            font-size: 1.4rem;
            display: grid;
            grid-template-columns: 1fr 6fr 1fr 1fr;
            grid-auto-rows: 1.4rem;
            ;
            grid-gap: .5rem;
            max-width: 70rem;

        }

        #output {
            width: 100%;
            height: 100%;
            background: #eee;
            overflow: auto;
            margin: 0;
        }
        #output p {
            border-bottom: 1px solid grey;
            padding-bottom: .25rem;
        }
        #header {
            display: flex;
            flex-direction: row;
            flex-wrap: wrap;
        }

        #header li {
            display: block;
            font-style: italic;
            font-size: 1.2rem;
            padding: .25rem;
            margin:0 1rem;
        }
    </style>

</head>

<body>
    <div id="page">
        <marquee>
            <div id="header"></div>
        </marquee>
        <main>
            <pre id="output"></pre>
        </main>
        <div id="controls">
            <label for="search">Message id:</label>
            <input type="search" id="search" name="search" enterkeyhint="search" value="1">
            <button type="button" id="searchBtn">Search!</button>
            <button type="button" id="allBtn">Show all</button>

            <label for="recipients">Send to:</label>
            <input type="text" id="recipients" name="search" value="">
            <span></span>

            <span></span><label for="recipients">Subject:</label>
            <input type="text" id="subject" name="search" value="">
            <span></span>
            <span></span>

            <label for="message">Message:</label>
            <textarea id="message" style="grid-row: span 4;">A message...</textarea>
            <button type="button" id="sendBtn">Send</button>
            <!-- Spans to move the logout button to the bottom -->
            <span></span><span></span><span></span><span></span><span></span><span></span><span></span><span></span>

            <button type="button" id="logoutBtn">Logout</button>
        </div>
        <div id="anchor"></div>
    </div>
</body>
<script>
    var anchor = document.getElementById('anchor');
    var searchField = document.getElementById('search');
    var messageField = document.getElementById('message');
    var recipientField = document.getElementById('recipients');
    var subjectField = document.getElementById('subject');
    var searchBtn = document.getElementById('searchBtn');
    var sendBtn = document.getElementById('sendBtn');
    var allBtn = document.getElementById('allBtn');
    var logoutBtn = document.getElementById('logoutBtn');
    var output = document.getElementById('output');
    var header = document.getElementById('header');

    var checkAnnouncements = async () => {
        res = await fetch('/announcements');
        anns = await res.json();
        if (anns && Array.isArray(anns.data)) {
            const elts = [];
            anns.data.forEach((element, idx) => {
                if (idx > 0) {
                    const node = document.createElement('li');
                    node.textContent = '  …  ';
                    elts.push(node);
                }
                const node = document.createElement('li');
                node.textContent = `${element.message || ''}`;
                elts.push(node);
            });
            console.log(elts);
            header.replaceChildren(...elts);
        }
    };
    // Stolen from this website: https://portswigger.net/web-security/cross-site-scripting/preventing
    function htmlEncode(str){
        return String(str).replace(/[^\w. ]/gi, function(c){
            return '&#'+c.charCodeAt(0)+';';
        });
    }
    var add_message = (message) => {
        const head = document.createElement('h3');
        head.innerHTML = `[${message.id}]: ` + "From " + message.sender + " to " + message.subjects + ": " + message.subject;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerText = message.text;
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        output.appendChild(body);
        anchor.scrollIntoView();
        checkAnnouncements();
    }
    var raw_msg_to_message = async (raw_msg) => {
        let sender = JSON.parse(await (await fetch(`/useridinfo?id=${encodeURIComponent(raw_msg[1])}`)).text())["username"];
        let subjects = "";
        for (const e of raw_msg[2].split(",")) {
            const id = parseInt(e.toString()) || 0;
            let username = JSON.parse(await (await fetch(`/useridinfo?id=${encodeURIComponent(id)}`)).text())["username"];
            if (subjects.length > 0)
                subjects += ", ";
            subjects += username;
        }
        return {
            "id": raw_msg[0],
            "sender": htmlEncode(sender),
            "subjects": htmlEncode(subjects),
            "subject": raw_msg[3],
            "text": raw_msg[4],
        };
    }
    var get_all_messages = async () => {
        res = await fetch("/messages");
        console.log(res);

        let json = JSON.parse(await res.text());
        for (const msg of json) {
            add_message(await raw_msg_to_message(msg));
        }
    }
    var get_message_with_id = async (msg_id) => {
        const q = `/messages/${encodeURIComponent(msg_id)}`;
        res = await fetch(q);
        console.log(res);

        let json = JSON.parse(await res.text());
        add_message(await raw_msg_to_message(json));
    };
    var send = async (recipients, subject, message) => {
        const q = `/new?recipients=${recipients}&subject=${encodeURIComponent(subject)}&message=${encodeURIComponent(message)}`;
        res = await fetch(q, { method: 'post' });
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = `[SENT]  ${q} → ${res.status} ${res.statusText}`;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
    };

    searchField.addEventListener('keydown', ev => {
        if (ev.key === 'Enter') {
            get_message_with_id(searchField.value);
        }
    });
    searchBtn.addEventListener('click', () => get_message_with_id(searchField.value));
    allBtn.addEventListener('click', () => get_all_messages());
    sendBtn.addEventListener('click', () => send(recipientField.value, subjectField.value, messageField.value));
    logoutBtn.addEventListener('click', () => window.location.href='/logout');
    checkAnnouncements();
</script>

</html>